login/urls.py
from django.urls import path
from .views import *

app_name = 'login'
urlpatterns = [
	path('register_admin', register_admin, name='register_admin'),
	path('register_penggunapublik',register_penggunapublik, name='register_penggunapublik'),
    path('register_dokter',register_dokter, name='register_dokter'),
    path('register_adminsatgas',register_adminsatgas, name='register_adminsatgas'),
    path('login_user', login_user, name='login_user'),
    path('logout_user', logout_user, name='logout_user')
]

rumah_sakit/urls.py
from django.urls import path
from .views import *

app_name = 'rumah_sakit'
urlpatterns = [
    path('reservasi_rs', reservasi_rs, name='reservasi_rs'),
    path('list_reservasi_rs', list_reservasi_rs, name='list_reservasi_rs'),
    path('delete_reservasi/<str:no>/<str:tgl>', delete_reservasi, name = 'delete_reservasi'),
    path('update_reservasi/<str:no>/<str:tgl>', update_reservasi, name = 'update_reservasi'),
    path('create_rs', create_rs, name='create_rs'),
    path('list_rs', list_rs, name='list_rs'),
    path('update_rs/<str:no>', update_rs, name='update_rs'),
]

siruco/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('', include('login.urls')),
    path('', include('dashboard.urls')),
    path('', include('CRUDpasien.urls')),
    path('', include('CRUDpaketmakan.urls')),
    path('', include('CRUhotel.urls')),
    path('', include('rumah_sakit.urls')),
    path('', include('transaksi.urls')),
    path('', include('faskes.urls')),
    path('', include('appointment.urls')),
    path('', include('jadwaldokter.urls')),
    path('', include('ruanganbedRS.urls')),
]

rumah_sakit/models.py
from django.db import models

# Create your models here.

rumah_sakit/forms.py
from django import forms
from django.db import connection
from collections import namedtuple
from django.http import HttpResponseRedirect
from django.urls import reverse
import datetime

class RegisterFormRS(forms.Form):
    cursor = connection.cursor()
    cursor.execute("set search_path to siruco;")
    cursor.execute("""select nik from pasien""")
    results = cursor.fetchall()
    cursor.close()
    connection.close()
    nik = []
    for row in results:
        nik.append(row[0])
    
    daftar_nik = []
    for value in nik:
        daftar_nik.append((value,value))

    cursor = connection.cursor()
    cursor.execute("set search_path to siruco;")
    cursor.execute("""select kode_faskes from rumah_sakit""")
    hasil = cursor.fetchall()
    cursor.close()
    connection.close()
    kode_rs = []
    for x in hasil:
        kode_rs.append(x[0])
    
    rscode = []
    for y in kode_rs:
        rscode.append((y,y))

    cursor = connection.cursor()
    cursor.execute("set search_path to siruco;")
    cursor.execute("select koderuangan from ruangan_rs")
    res = cursor.fetchall()
    cursor.close()
    connection.close()
    kod = []

    for z in res:
        kod.append(z[0])

    roomcode = []
    for w in kod:
        roomcode.append((w,w))

    cursor = connection.cursor()
    cursor.execute("set search_path to siruco;")
    cursor.execute("select distinct kodebed from bed_rs")
    rsult = cursor.fetchall()
    cursor.close()
    connection.close()
    bed = []
    for b in rsult:
        bed.append(b[0])

    bedcode = []
    for c in bed:
        bedcode.append((c,c))

    
    kodepasien = forms.ChoiceField(label=("NIK:"),choices = daftar_nik, widget = forms.Select({'class':'form-control'}))
    tglmasuk = forms.DateField(initial=datetime.date.today)
    tglkeluar = forms.DateField(initial=datetime.date.today)
    koders = forms.ChoiceField(label=("Kode RS:"),choices = rscode, widget = forms.Select({'class':'form-control'}))
    koderuangan = forms.ChoiceField(label=("Kode Ruangan:"),choices = roomcode, widget = forms.Select({'class':'form-control'}))
    kodebed = forms.ChoiceField(label=("Kode Bed:"),choices = bedcode, widget = forms.Select({'class':'form-control'}))

class UpdateResRS(forms.Form):
    tglmasuk = forms.DateField(disabled=True)

class CreateRS(forms.Form):
    cursor = connection.cursor()
    cursor.execute("set search_path to siruco;")
    cursor.execute("""select kode from faskes""")
    results = cursor.fetchall()
    cursor.close()
    connection.close()
    cod = []
    for row in results:
        cod.append(row[0])
    
    kodefk = []
    for value in cod:
        kodefk.append((value,value))
    
    pilihan = []
    pilihan.append((0,0))
    pilihan.append((1,1))

    
    kode_faskes = forms.ChoiceField(label=("Kode:"),choices = kodefk, widget = forms.Select({'class':'form-control'}))
    #rujukan = forms.ChoiceField(label=("Rujukan:"),choices = pilihan, widget = forms.Select({'class':'form-control'}))

rumah_sakit/views.py
from django.shortcuts import render
from django.db import connection
from collections import namedtuple
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib import messages
from .forms import *
from datetime import datetime

# Create your views here.
def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]

def reservasi_rs(request):
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')
    username = request.session['username']
    role= request.session['role']

    if role != 'admin_satgas':
        return HttpResponseRedirect('/dashboard')
        messages.error("Unauthorized access for reservasi")

    else:
        if request.method == 'POST':
                registform = RegisterFormRS(request.POST)
                if registform.is_valid():
                    kodepasien = registform.cleaned_data['kodepasien']                        
                    tglmasuk = registform.cleaned_data['tglmasuk']
                    tglkeluar = registform.cleaned_data['tglkeluar']
                    koders = registform.cleaned_data['koders']
                    koderuangan = registform.cleaned_data['koderuangan']
                    kodebed = registform.cleaned_data['kodebed']
                    if check_reservasi_is_exist(kodepasien, tglmasuk) == False:
                        if tglkeluar < tglmasuk:
                            messages.error(request, 'Tanggal keluar tidak boleh sebelum tanggal masuk')
                            return HttpResponseRedirect('/reservasi_rs')

                        with connection.cursor() as c:
                            c.execute("INSERT INTO RESERVASI_RS VALUES (%s, %s, %s, %s, %s, %s, %s)",[kodepasien, tglmasuk, tglkeluar, koders, koderuangan, kodebed, "V0001"])
                        #    c.execute("SELECT * FROM PENGGUNA_PUBLIK")
                        #    data = dictfetchall(c)
                        #    print(data)
                        return HttpResponseRedirect(reverse('dashboard:dashboard')) # CHANGE TO DESIRED APP
                    else:
                        messages.error(request, 'Username/Email sudah terdaftar')
                        return HttpResponseRedirect('/reservasi_rs')
        register_form = RegisterFormRS()
        response = {'reservasi_rs':register_form}
        return render(request,'reservasi_rs.html',response)

def list_reservasi_rs(request):
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')
    username = request.session['username']
    role= request.session['role']
    cursor_p = connection.cursor()

    if role == 'admin_satgas' or 'pengguna_publik':
        select="SELECT * FROM SIRUCO.RESERVASI_RS;"
        cursor_p.execute(select)
        data= namedtuplefetchall(cursor_p)
        #print(data)
        if role =='admin_satgas':
            return render(request,'list_reservasi_rs.html',{ 'data':data})
        elif role == 'pengguna_publik':
            return render(request,'list_reservasi_rs_pp.html',{ 'data':data})
        else:
            return HttpResponseRedirect('/dashboard')
            messages.error("Unauthorized access for list reservasi")

def delete_reservasi(request, no, tgl):
    role= request.session['role']
    if role =='admin_satgas':
        with connection.cursor() as c:
            c.execute("SET search_path to SIRUCO")
            c.execute("DELETE FROM TRANSAKSI_RS where kodepasien = %s AND tglmasuk = %s",[no, tgl])
            c.execute("DELETE FROM RESERVASI_RS where kodepasien = %s AND tglmasuk = %s",[no, tgl])
        return HttpResponseRedirect('/list_reservasi_rs')
    else:
        return HttpResponseRedirect('/dashboard')
        messages.error("Unauthorized access for delete reservasi")

def update_reservasi(request, no, tgl):
    role= request.session['role']
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')

    if request.method == 'POST':
        kodepasien = request.POST.get('idpasien')
        tglmasuk = request.POST.get('indate')
        tglkeluar = request.POST.get('outdate')
        cursor_p = connection.cursor()
        select="UPDATE SIRUCO.RESERVASI_RS SET tglkeluar= '"+tglkeluar+"' WHERE kodepasien='"+no+"' AND tglmasuk='"+tgl+"';"
        change="UPDATE SIRUCO.TRANSAKSI_RS SET totalbiaya= abs('"+tglkeluar+"' :: date - '"+tgl+"' :: date)*500000 WHERE kodepasien='"+no+"' AND tglmasuk='"+tgl+"';"
        cursor_p.execute(select)
        cursor_p.execute(change)
        return HttpResponseRedirect('/list_reservasi_rs')
    
    else:
        username = request.session['username']
        role= request.session['role']
        if role == 'admin_satgas':
            cursor_p = connection.cursor()
            select="SELECT * FROM SIRUCO.RESERVASI_RS WHERE kodepasien='"+no+"' AND tglmasuk='"+tgl+"';"
            cursor_p.execute(select)
            data= dictfetchall(cursor_p)
            data_res = data[0]
            return render(request,'update_reservasi.html',{'data_res':data_res})
        else:
            return HttpResponseRedirect('/dashboard')
            messages.error("Unauthorized access for update reservasi")
            
def create_rs(request):
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')
    username = request.session['username']
    role= request.session['role']

    if role != 'admin_satgas':
        return HttpResponseRedirect('/dashboard')
        messages.error("Unauthorized access for reservasi")

    else:
        if request.method == 'POST':
                registform = CreateRS(request.POST)
                isrujukan = request.POST.get('isrujukan')
                
                if isrujukan == "on":
                    isrujukan = "1"
                else:
                    isrujukan = "0"

                if registform.is_valid():
                    kode_faskes = registform.cleaned_data['kode_faskes']
                    # rujukan = registform.cleaned_data['rujukan']
                    if check_kode_faskes_is_exist("RUMAH_SAKIT", kode_faskes) == False:
                        with connection.cursor() as c:
                            c.execute("INSERT INTO RUMAH_SAKIT VALUES (%s, %s)",[kode_faskes, isrujukan])
                        return HttpResponseRedirect('/list_rs')
                    else:
                        messages.error(request, 'RS sudah terdaftar')
                        return HttpResponseRedirect('/create_rs')
        register_form = CreateRS()
        response = {'create_rs':register_form}
        return render(request,'create_rs.html',response)

def list_rs(request):
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')
    username = request.session['username']
    role= request.session['role']
    cursor_p = connection.cursor()

    if role == 'admin_satgas':
        select="SELECT * FROM SIRUCO.RUMAH_SAKIT;"
        cursor_p.execute(select)
        data= namedtuplefetchall(cursor_p)
        #print(data)
        return render(request,'list_rs.html',{ 'data':data})
    else:
        return HttpResponseRedirect('/dashboard')
        messages.error("Unauthorized access for list transaksi")

def update_rs(request, no):
    role= request.session['role']
    if 'username' not in request.session:
        return HttpResponseRedirect('/login_user')

    if request.method == 'POST':
        kode_faskes = request.POST.get('kode_faskes')
        isrujukan = request.POST.get('isrujukan')
        if isrujukan == "on":
            isrujukan = "1"
            cursor_p = connection.cursor()
            select="UPDATE SIRUCO.RUMAH_SAKIT SET isrujukan= '"+isrujukan+"' WHERE kode_faskes ='"+no+"';"
            cursor_p.execute(select)
        else:
            isrujukan = "0"
            cursor_p = connection.cursor()
            select="UPDATE SIRUCO.RUMAH_SAKIT SET isrujukan= '"+isrujukan+"' WHERE kode_faskes ='"+no+"';"
            cursor_p.execute(select)

        return HttpResponseRedirect('/list_rs')
    
    else:
        username = request.session['username']
        role= request.session['role']
        if role == 'admin_satgas':
            cursor_p = connection.cursor()
            select="SELECT * FROM SIRUCO.RUMAH_SAKIT WHERE kode_faskes='"+no+"';"
            cursor_p.execute(select)
            data= dictfetchall(cursor_p)
            data_res = data[0]
            return render(request,'update_rs.html',{'data_res':data_res})
        else:
            return HttpResponseRedirect('/dashboard')
            messages.error("Unauthorized access for update reservasi")

def check_kode_faskes_is_exist(table, kode_faskes):
    data = {}

    with connection.cursor() as c:
        c.execute("SET search_path to SIRUCO")
        c.execute("SELECT * FROM %s where kode_faskes = %s " % (table, '%s'),[kode_faskes])
        data = dictfetchall(c)
    return len(data) > 0 

def check_reservasi_is_exist(kodepasien, tglmasuk):
    data = {}
    with connection.cursor() as c:
        c.execute("SET search_path to SIRUCO")
        c.execute("SELECT * FROM RESERVASI_RS where kodepasien = %s AND tglmasuk = %s",[kodepasien, tglmasuk])
        data = dictfetchall(c)
    return len(data) > 0 

def dictfetchall(cursor):
    "Return all rows from a cursor as a dict"
    columns = [col[0] for col in cursor.description]
    return [
        dict(zip(columns, row))
        for row in cursor.fetchall()
    ]

rumah_sakit/templates/create_rs.html
<div>
    <form action='' method="POST" class="form-group">
        {% csrf_token %}
        {% for field in create_rs %}
        <div class="form-group">
            {{ field.label_tag }} {{field}}
            <label>Rujukan?</label>
            <input name = "isrujukan" type="checkbox"><br>
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="Submit">
        </div>
    </form>
</div>

rumah_sakit/templates/list_reservasi_rs.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
{% block content %}
    <head>
        <style>
            table {
              font-family: arial, sans-serif;
              border-collapse: collapse;
              width: 100%;
            }
            
            td, th {
              border: 1px solid #dddddd;
              text-align: left;
              padding: 8px;
            }
            
            tr:nth-child(even) {
              background-color: #dddddd;
            }
            </style>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Daftar Kelas</title>
    </head>
    <body style="text-align: center;">
        <h2>Daftar Reservasi RS:</h2>
        {% if data %}
            <table>
                <tr>
                    <th>NIK Pasien</th>
                    <th>Tanggal Masuk</th>
                    <th>Tanggal Keluar</th>
                    <th>RS</th>
                    <th>Ruangan</th>
                    <th>Bed</th>
                    <th>Action</th>
                </tr>
            {% for baris in data%}
                <tr>
                    <td>{{ baris.kodepasien }}</td>
                    <td>{{ baris.tglmasuk }}</td>
                    <td>{{ baris.tglkeluar }}</td>
                    <td>{{ baris.koders }}</td>
                    <td>{{ baris.koderuangan }}</td>
                    <td>{{ baris.kodebed }}</td>
                    <td>
                        <a href="{% url 'rumah_sakit:delete_reservasi' no=baris.kodepasien tgl=baris.tglmasuk %}">Delete</a>
                        <a href="{% url 'rumah_sakit:update_reservasi' no=baris.kodepasien tgl=baris.tglmasuk %}">Update</a>
                    </td>

                    {% csrf_token %}
                </tr>
            <br/>
            {% endfor %}
        </table>
    {% endif %}
    </body>
    {% endblock content %}
</html>

rumah_sakit/templates/list_reservasi_rs_pp.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
{% block content %}
    <head>
        <style>
            table {
              font-family: arial, sans-serif;
              border-collapse: collapse;
              width: 100%;
            }
            
            td, th {
              border: 1px solid #dddddd;
              text-align: left;
              padding: 8px;
            }
            
            tr:nth-child(even) {
              background-color: #dddddd;
            }
            </style>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Daftar Kelas</title>
    </head>
    <body style="text-align: center;">
        <h2>Daftar Reservasi RS:</h2>
        {% if data %}
            <table>
                <tr>
                    <th>NIK Pasien</th>
                    <th>Tanggal Masuk</th>
                    <th>Tanggal Keluar</th>
                    <th>RS</th>
                    <th>Ruangan</th>
                    <th>Bed</th>
                </tr>
            {% for baris in data%}
                <tr>
                    <td>{{ baris.kodepasien }}</td>
                    <td>{{ baris.tglmasuk }}</td>
                    <td>{{ baris.tglkeluar }}</td>
                    <td>{{ baris.koders }}</td>
                    <td>{{ baris.koderuangan }}</td>
                    <td>{{ baris.kodebed }}</td>
                    {% csrf_token %}
                </tr>
            <br/>
            {% endfor %}
        </table>
    {% endif %}
    </body>
    {% endblock content %}
</html>

rumah_sakit/templates/list_rs.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
{% block content %}
    <head>
        <style>
            table {
              font-family: arial, sans-serif;
              border-collapse: collapse;
              width: 100%;
            }
            
            td, th {
              border: 1px solid #dddddd;
              text-align: left;
              padding: 8px;
            }
            
            tr:nth-child(even) {
              background-color: #dddddd;
            }
            </style>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Daftar RS</title>
    </head>
    <body style="text-align: center;">
        <h2>Daftar RS:</h2>
        {% if data %}
            <table>
                <tr>
                    <th>Kode Faskes</th>
                    <th>Rujukan?</th>
                    <th>Action</th>
                </tr>
            {% for baris in data%}
                <tr>
                    <td>{{ baris.kode_faskes }}</td>
                    <td>{% if baris.isrujukan == "1" %}&#10004;{% else %}&times;{% endif %}</td>
                    <td>
                        <a href="{% url 'rumah_sakit:update_rs' no=baris.kode_faskes %}">Update</a>
                    </td>
                    {% csrf_token %}
                </tr>
            <br/>
            {% endfor %}
        </table>
    {% endif %}
    </body>
    {% endblock content %}
</html>

rumah_sakit/templates/reservasi_rs.html
<div>
    <form action='' method="POST" class="form-group">
        {% csrf_token %}
        {% for field in reservasi_rs %}
        <div class="form-group">
            {{ field.label_tag }} {{ field }}
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="Register">
        </div>
    </form>
</div>

rumah_sakit/templates/update_reservasi.html
<div id="myTabContent" class="tab-content">
    <div class="tab-pane active in" id="home">
        <form action='' method="POST" class="form-group">
            {% csrf_token %}
            <div>
                <label>Kode Pasien</label>
                <input name = idpasien type="text" value="{{data_res.kodepasien}}" class="input-xlarge" disabled>
                <div class="text-center text-sm-right"></div>
                <label>Tanggal Masuk</label>
                <input name = 'indate' type="text" value="{{data_res.tglmasuk}}" class="input-xlarge" disabled>
                <label>Tanggal Keluar</label>
                <input name = 'outdate' type="date" value="{{data_res.tglkeluar|date:'Y-m-d'}}" min ="{{data_res.tglmasuk|date:'Y-m-d'}}" class="input-xlarge">
                <label>Kode RS</label>
                <input type="text" value="{{data_res.koders}}" class="input-xlarge" disabled>
                <label>Kode Ruangan</label>
                <input type="text" value="{{data_res.koderuangan}}" class="input-xlarge" disabled>
                <label>Kode Bed</label>
                <input type="text" value="{{data_res.kodebed}}" class="input-xlarge" disabled>
                <input type="submit" value="Submit">
            </div>
    </div>
    </form>
</div>

rumah_sakit/templates/update_rs.html
<div id="myTabContent" class="tab-content">
    <div class="tab-pane active in" id="home">
        <form action='' method="POST" class="form-group">
            {% csrf_token %}
            <div>
                <label>Kode Faskes</label>
                <input name = 'kode_faskes' type="text" value="{{data_res.kode_faskes}}" class="input-xlarge" disabled>
                <div class="text-center text-sm-right"></div>
                <label>Rujukan?</label>
                <input name = 'isrujukan' type="checkbox" class="input-xlarge">
                <input type="submit" value="Submit">
            </div>
    </div>
    </form>
</div>